﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;


using MindFusion.Diagramming;
using MindFusion.Diagramming.WinForms;
using MindFusion.Drawing;

namespace WindowsFormsApp39
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

			img1 = ScaleImage("P1030886.JPG", 40, 40);
			img2 = Image.FromFile("P1030886.JPG");

			var view = new DiagramView();
			Controls.Add(view);
			view.SetBounds(0, 100, 800, 500);

			var diagram = view.Diagram;
			var node1 = diagram.Factory.CreateShapeNode(20, 20, 20, 20);
			var node2 = diagram.Factory.CreateShapeNode(50, 20, 20, 20);
			node1.Image = img1;
			node1.ImageAlign = ImageAlign.Stretch;
			node2.Image = img2;
			node2.ImageAlign = ImageAlign.Stretch;

			var node3 = diagram.Factory.CreateShapeNode(20, 70, 8, 8);
			var node4 = diagram.Factory.CreateShapeNode(50, 70, 8, 8);
			node3.Image = img1;
			node3.ImageAlign = ImageAlign.Stretch;
			node4.Image = img2;
			node4.ImageAlign = ImageAlign.Stretch;
		}

		static Bitmap ScaleImage(string pathname, int maxWidth, int maxHeight)
		{
			// See: https://stackoverflow.com/questions/6501797/resize-image-proportionally-with-maxheight - and - maxwidth - constraints


			try
			{
				var bitmap = new Bitmap(pathname);

				var ratioX = (double)maxWidth / bitmap.Width;
				var ratioY = (double)maxHeight / bitmap.Height;

				var ratio = Math.Min(ratioX, ratioY);

				var newWidth = (int)(bitmap.Width * ratio);
				var newHeight = (int)(bitmap.Height * ratio);

				var scaledBitmap = new Bitmap(bitmap, newWidth, newHeight);
				bitmap.Dispose();

				return scaledBitmap;
			}

			catch
			{
				// If there's not enough memory the above code can fail.
				// Also, 'pathname' may not be able to be converted into a Bitmap.
				return null;
			}
		}

		protected override void OnPaint(PaintEventArgs e)
		{
			base.OnPaint(e);

			/*Image img1 = Image.FromFile("P1030886.JPG");
			//Image img1 = new Bitmap("P1030886.JPG");
			Bitmap img2 = new Bitmap(img1, 40, 40);
			img1.Dispose();
			e.Graphics.DrawImage(img2, 0, 0);*/

			
			e.Graphics.DrawImage(img1, 0, 0);
			e.Graphics.DrawImage(img2, 60, 0);
		}

		Image img1;
		Image img2;
	}
}
